% https://www.dubaro.de/mixxxer.php?products_id=3343, configuration id 234086

% File with general header information.
% Like all the packages that we need to include and very common commands
% that we use.
\input{inc/header.tex}

% File with "general commands". Those are commands  and environments
% that we find useful throughout many papers (and other kinds of documents).
\input{inc/generalCommands.tex}

% File with "specific commands". Those are commands that may be rather
% specific to the current document (like shortcuts to some notation).
\input{inc/specificCommands.tex}

\newcommand{\q}[1]{\noindent\textbf{Question:} #1 \vspace{1em}}

\renewcommand{\a}[1]{\noindent\emph{Answer:} #1 \vspace{1.5em}}

% Start of the actual document.
\begin{document}
  \selectlanguage{english}

  \section{Q \& A}

  \q{Genauer Ablauf des Libratus-Experiments?}

  \a{Four top poker players played against Libratus in teams of 2, each getting the respective others' hands for sake of symmetry. Fixed salary for that was 20k each, and another 140k were split based on performance. The players wer Jason Les, Dong Kim, Daniel McAulay, Jimmy Chou. They played 120,000 hands over 20 days. In the end, they were roughly 1.8 billion dollars in the minus, corresponding to a loss of roughly 14.7mbb.}


  \q{Details zu Libratus' Implementation: Wie wurde abstrahiert, gel\"ost, was macht der online L\"oser, wie funktioniert der Self-Improver?}

  \a{The abstraction war partially based on domain knowledge and partially stemmed from automatic algorithms, which reduced the game size to several million to maybe a few billion.
  Cards in the first three rounds were not abstracted at all and bet sizes were put to ``popular'' multiples of the pot size.
  The online solver plays according to the blueprint strategy in the first few rounds (mapping actions to the abstract ones probabilistically).
  In the later stages, the so-called \emph{nested endgame solver} is activated, which extends the abstraction by the moves that are actually played by the opponent.
  This has to be done carefully, because it is not just enough to look at the sub-game itself, but also the remaining blueprint strategy needs to be taken into account.
  A big algorithmic advancement in this context is the development of save and performant subgame solving.
  Its basic idea is to create a modified game for real-time solving (one that consists of the original game plus an ``exit'' option for the opponent with an estimated value of that game) plus a way to take into account strategically less likely (or plausible) hands.
  Finally, the self-improver simply checks (especially during the first rounds) if certain bet sizes are done repeatedly.
  }

  \q{Details zur Rechenpower: Konsumierte Leistung, Gr\"o{\ss}e des Superrechners, Live-Rechenzeit}

  \a{It used the \emph{Bridges system}, which is a cloud-like supercomputer located in Pittsburgh with 1.35 PFLOPS. Libratus was running on 600 of 846 nodes with 2x28 CPUs and 128GB of RAM each, plus a lot of GPUs, an some with 3TB of RAM even. Libratus used up 2.6 Petabytes of data during competition. It spent between 15 and 19 million compute hours.}

  \q{Poker: Was sind die typischen Problemgr\"o{\ss}en?}

  \a{Problem sizes are freely scalable. There are versions that can even by solved by hand. The game can be made arbitrarily complex, too, by increasing bet sizes.}

  \q{Wie schl\"agt sich der ANN Ansatz von DeepStack im Vergleich?}

  \a{The DeepStack ANN had a limited-lookahead approach where it would try to estimate the values of the nodes at the search-limit using a neural network, and then solve the given (sub) game in real-time. It was also able to defeat poker professionals, however those were not top players. Moreover, it never entered the annual computer poker competition, so there are also no reference values on how it would perform against the other AIs, whereas for libratus it is known that it outperforms older AIs by a large.}

  \q{Wie sehen Monte--Carlo-Ans\"atze zur Equilibriumsfindung aus?}

  \a{Monte--Carlo based methods rely on CounterFactualRegret algorithms, which essentially keep track of the so-called regret.
  That is a value that tells how much more one could have made in a certain information set by taking another action.
  CFR algorithms suffer from a worse complexity bound ($1/\epsilon^2$), but they have the benefit that they allow pruning by leaving out branches of low- or no-regret.
  The Monte--Carlo approach essentially is to sample those actions according to the ``right'' probability distribution.
  In application, (MC)CFR outperforms excessive gap techniques (EGT), which is also why Libratus is using that.
  However, there has been recent work with numerical results in favor of EGT methods, so the game is still open.
  }

  \q{St\"arken und Schw\"achen der MCMs, besonders im Vergleich zu den iterativen Verfahren erster Ordnung?}

  \a{Basically just the inferior complexity bound (see above), which however is not so clear in application. Potentially it also feels a little better suited for parallelization.}

  \q{Was sind die neuesten Entwicklungen bei den EGT, sodass diese nun mit CFR konkurrieren k\"onnen?}

  \a{One important improvement is to step away from the Euclidean regularization term in the gap function and transition to an entropy based one, which appears to perform better.
  Also, those formulations are made compatible with so-called treeplexes to reduce the problem complexity; it can be shown that the projections are then still inexpensive.
  Then there are adaptive methods for choosing the smoothing parameter.
  Finally, using the treeplex structure, it also became feasible to use strong parallelization techniques which even run well on GPUs.
  }

  \q{Wie funktioniert Parallelisierung in der algorithmischen Spieltheorie?}

  \a{In case of Monte--Carlo methods the parallelization is somewhat straightforward, at least as long as the system has a shared memory architecture. Else the updates on some of the book-keeping are too expensive due to high memory latency. Therefore, an idea for significantly larger scales is to create game abstractions that allow assigning different components of the tree to different blades.}

  \q{Wie sehen sparse/low-rank Formulierungen und Treeplexes aus?}

  \a{Sparse formulations are clear. What you can use in games like poker is that there is a representation in terms of Kronecker products of significantly smaller matrices. On top, you can use so-called treeplexes, which are a generalization of simplices to fit with tree-like structures.}

  \q{Wie ist der Brouwersche Fixpunktsatz definiert?}

  \a{Any continuous self-mapping onto a compact convex set $f\colon K \rightarrow K$ has a fixed point.}

  \q{Wie ist Kakutani Fixpunktsatz formuliert?}

  \a{Let $S \neq \emptyset$ convex and compact and finite-dimensional. If $\varphi\colon S \rightarrow 2^S$ has a closed graph and $\varphi(x)$ is non-empty and convex for all $x \in S$, then $\varphi$ has a fixed point.}

  \q{Beweisskizze des Nash Theorems?}

  \a{Consider the space of strategies and define a (local) function that would give a better strategy for each player. Show that this function is continuous and thus has a fixed point. The proof finishes with the insight that a fixed point is equivalent to having an equilibrium.}

  \q{Beweisskizze des Kuhn Theorems?}

  \a{Basically just make this construction and prove the claim inductively over the level of the tree.}

  \q{Ergebnisse/Referenzen zur min-max Formulierung und \"Aquivalenz zum linearen Programm?}

  \a{There is a result dating back to von Neumann in 1928 where he proves that any convex-concave function over the cartesian product of convex sets alows to interchange the min/max order.
  The equivalence to the linear program is also a standard result from game theory, which might also date back to Neumann, or at least Kuhn.}

  \q{Vorteile/Nachteile der versch. Strategiebegriffe, insbesondere mit Blick auf die Komplexit\"at der dazu geh\"orenden Strategier\"aume?}

  \a{The mixed strategy perspective is the most easy for stating the problem.
  However, it is highly prohibitive from a numerical perspective, as it suffers from a blow-up in size -- as the dimension of the corresponding strategy space is equal to the product over the sizes of all action sets.
  Instead, the sequence form yields a strategy space that corresponds to the sum of possible actions over all information sets, which in general would be significantly lower.
  }

  \q{Was hat es mit der sequence form auf sich?}

  \a{The sequence form's strategy concept (called realization plan) is more directly considering the probability distribution over game states that is induced by a behavioral strategy, and it makes use of the fact that each action in a game of perfect recall can be identified by a sequence of actions since the game root (including the chance player actions).
  Therefore, in sequence from one prescribes the probability of taking a certain action \emph{at all} (modulo chance?).
  This makes each realization plan an element of a standard simplex that also needs to fulfill further constraints, namely it needs to distribute an action's probability over all actions at a node.
  }  

  \q{Alternative L\"osungskonzepte zu Nash?}

  \a{Not that I am aware of anything fundamentally different. But there are various refinements that e.\,g. require optimality in subgames as a sort of consistency condition.}

  \q{Was kann man bei $n > 2$ oder $u_1 + u_2 \neq 0$ noch tun? Was genau schl\"agt dann fehl?}

  \a{In multiplayer or non-zero-sum games the min-max matrix game formulation is no longer applicable which is a foundation for many algorithms.
  Furthermore, the solution of those games is in a complexity class for which no polynomial time solution algorithm is known.
  However, there are still solution methods.
  For example, one is based on a similar formulation as the excessive gap technique.
  Yet another one essentially is a homotopy method, giving the players generous bonuses in the extreme case which make the opponents' impact negligible.}

  \q{Was sind die konzeptionellen Probleme, die ein Nash-Equilibrium bei $n > 2$ Spielern oder in Nicht-Nullsummenspielen hat?}

  \a{Generally, Nash-Equilibria are not unique. However, in two player zero sum games, it does not matter which Nash-equilibrium is picked, because they necessarily all do equally well.
  Also, if an opponent decides to not play a Nash equilibrium, they necessarily lose money. Of course, if the opponent does not play a Nash equilibrium, we might be even better off by switching the strategy ourselves.
  However, only the Nash-equilibrium can give us this safety promise.
  If either of those properties fails, these properties simply are no longer clear.
  For example, we could become unnecessarily exploitable if the opponents actually fail to (or simply not want to) play a Nash-equilibria themselves.
  However, there have been at least a few numerical experiments for some games suggesting that playing a Nash equilibrium in multiplayer games can do fairly well.
  But the research on that feels by no means exhaustive.
  }

  \q{Wie funktioniert CFR?}

  \a{Given a concrete run of the game, counterfactual regret is a way to measure loss (or gain) of utility that stems from choosing one action over another.
  Counterfactual regret minimization is then an approach to update probabilities at each information set using both the current and past regret values.
  In particular, it is an algorithm where the machine plays against itself.}

  \q{Wie gro{\ss} sind die Spiele, die sich jetzt l\"osen lassen?}

  \a{The latest result which I know with explicit numbers and without abstraction had around $10^{16}$ nodes or $10^{11}$ information sets, which then needs to run on a supercomputer with 900 cores for a million core hours. I suspect that Libratus might have increased on that a little further, but that should still be the general ballpark.}

  \q{Was ist die Komplexit\"at linearer Programme und des Simplexverfahrens?}

  \a{The simplex method has an exponential complexity and one might not really be able to improve upon that; it simply can happen that all corners need to be visited. Howeer, in general linear programs are in the complexity class P as they are just simple convex problems. In that context, IP methods have a $\log(1/\eps)$ rate of convergence, which is sadly combined with significantly higher memory requirements.}

  \q{Beispiel f\"ur Nicht\"aquivalenz gemischter und behavioristischer Strategien?}

  \a{It is relatively simple to see from a game with just one single player and the pure strategies $(L,U)$, $(L,D)$, $(R,U)$, $(R,D)$ and just one information set per level. It is possible to state a mixed strategy that can only reach either $(L,D)$ or $(R,U)$, but it is not possible to to that for a behavioral strategy beacuse it must decide between either $D$ or $U$.}

  \q{In welchem Sinn sind $f$ und $\phi$ zueinander dual?}
  
  \a{At first, just in the sense that there is a gap which is zero if and only if an optimal point is reached. But there is the connection to the linear programs and their dual formulations. In that sense it is a classical Lagrangian duality.}

  \q{Ist klar, warum $f$ konvex ist?}
  
  \a{Yes, it is pretty clear. Just plug in the definition and use $\max_{y} (x_1 + x_2)^TAy \leq \max_{y} x_1^TAy + \max_{y} x_2^TAy$.}

  \q{Was sind $(\wt{u}, \wt{v})$?}
  
  \a{Those are points that may be chosen arbitrarily inside the admissible set. For the uniform approximation property I chose them to be the center of gravity of the simplices.}

  \q{Beweis der uniformen Approximationseigenschaft?}

  \a{It's relatively simple: If $\wt{u} = (1/n, \dots, 1/n)$, then Jensen's inequality quickly requeals that $\norm{u-\wt{u}}^2 \leq \sum \lambda_i \norm{e_i - \wt{u}}^2 = \norm{e_1 - \wt{u}}^2 = 1-\frac{1}{n}$.
  In particular, the smoothing term is bounded by $2 \cdot \frac{\mu}{2} = 2$.
  }

  \q{Genaue Konvergenzraten von Subgradientenverfahren und projizierten Gradientenverfahren?}
  
  \a{Subgradient methods in their most general form have a proven (worst-case) rate of convergence of order $\mathcal{O}(1/\eps^2)$ (even for Krylov-type formulations). Classical gradient descent should have order $\mathcal{O}(1/\eps)$, as well as projected gradient descent. Confer also https://www.cs.cmu.edu/~ggordon/10725-F12/slides/08-general-gd.pdf on the generalized gradient descent method.}

  \q{Tieferer Einblick in die Funktionsweise des Nesterov-Algorithmus?}
  
  \a{Some interesting insights: The Nesterov algorithm has two separate components, namely the smoothing part and the convex solver.
  Note that just smoothing and then applying the projected gradient algorithm yields a rate of convergence of order $\mathcal{O}(1/\eps^2)$, which is the same as for applying the subgradient method.
  Therefore, there is a real contribution from Nesterov's work.
  It essentially leverages the fact that the smoothed functional is strongly convex.
  The subproblem that is solved in each step stems from minimizing the functional resulting from the convex modulus, which could also be interpreted as a SQP where the second order term is approximated by the identity matrix times the convex modulus.
  Alterantively, the projection step may also be considered as a gradient projection step with a fixed step size that is inversely proportional to the convex modulus.
  In addition, there is a convex weighting between the minimizer of the convex modulus functional and the minimizer of a similar functional that uses the past history of gradients, kind of like a Krylov subspace optimization.
  That component is necessary in order to ensure that the function value of the first items remains sufficiently small, relative to the sum of all step sizes.
  }

  \q{Beweis der $\log(1/\eps)$-Schranke?}
  
  \a{First, for each outer iteration, the $1/\eps_i$ term in the number of Nesterov iterations is exchanged by a $\delta$ because $\norm{z_0 - z} \leq \delta \eps_i$, which is a constant that would be visible if the bound on the slides was more explicit.
  Also note that $\eps_0 = F(z_0) \leq 2\norm{A}$ and therefore $\eps_i \leq 2\norm{A} \gamma^i$ with $\gamma = 1/e$.
  This means that the bound $\eps$ is reached after $N \geq \ln(2\norm{A}/\eps)$ outer iterations.
  The result then follows by simple multiplication.
  }

  \q{Beschr\"anktheit und Eigenschaften des Konvergenzma{\ss}es $\delta$? Unterschied zur Definition aus der CoMa?}
  
  \a{The boundedness can be shown using again Jensen-type/convexity based estimates. The main difference to the definition from CoMa is the non-locality.}

  \q{Was w\"aren geeignete Konsistenzbedingungen in der Abstraktion?}
  
  \a{For example that abstractions of nodes also need to map to abstractions of their corresponding information set, and that the abstraction of actions needs to also stay with the abstract information set and preserve the ``constant cardinality partition'' property. Moreover, of course player associations need to be preserved, too.}

  \q{Gibt es ausgekl\"ugeltere Prolongationskonzepte?}
  
  \a{Partially. Actually, the restriction is mostly the part that can be done better by probabilistic mapping of input actions in order to avoid exploitability. The prolongation might be randomizes a little, to, but I am not aware of any concepts that would go beyond heuristics.}

  \q{Wie funktioniert der Beweis zur Approximationsschranke? Gibt es weitere Ergebnisse?}
  
  \a{The proof works on an induction over the tree from bottom to top. There are further results concerning imperfect-recall abstractions and bounds for $\eps$-Nash equilibria in the abstract game.}

  \q{Welche Problemgr\"o{\ss}e erreicht man mit den hier beschriebenen Verfahren?}
  
  \a{Altogether, the biggest size achieved yet appears the $10^{161}$ bound.
  However, this depends heavily on the abstraction and how much expert knowledge you are able to bring in.}

  \q{Zusammenhang zur Forschung am Fachbereich? Markov-Chain/Monte--Carlo Verfahren? Coarse graining? Numerik von PDEs?}
  
  \a{The MC methods are most closely related to what is done for CFR-minimization.
  Coarse graining could be in the broadest sense an idea for abstraction, but it is not clear at all how that should be done.
  The discretization and optimization components exhibit similarities to PDE theory, but of course lack the functional analysis background.
  However, there are also continuous games, which could make this topic even more exciting (and challenging).
  }

  \q{Bessere Motivation: Relevanz Spieltheorie!}

  \q{Bessere Motivation: Weitere Forschung an iterativen Verfahrn!}

  \q{Bessere Motivation: Einf\"uhrung und Forschung f\"ur Spielabstraktion!}

  \q{Bessere Schlussformulierung!}

\end{document}

